Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 2231)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography and surface concept
+! Modify passed parameters for disturb_field
 ! 
 ! Former revisions:
@@ -278,6 +279,6 @@
                dt_dopr_listing, dt_dots, dt_dvrp, dt_run_control,              &
                end_time, first_call_lpm, galilei_transformation, humidity,     &
-               intermediate_timestep_count,                                    &
-               intermediate_timestep_count_max, large_scale_forcing,           &
+               intermediate_timestep_count, intermediate_timestep_count_max,   &
+               land_surface, large_scale_forcing,                              &
                loop_optimization, lsf_surf, lsf_vert, masks,                   &
                microphysics_seifert, mid, nest_domain,                         &
@@ -308,6 +309,5 @@
 
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt, &
-               nzb_u_inner, nzb_v_inner
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
 
     USE interaction_droplets_ptq_mod,                                          &
@@ -319,5 +319,5 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, lsm_energy_balance, lsm_soil_model,               &
+        ONLY:  lsm_energy_balance, lsm_soil_model,                             &
                skip_time_do_lsm
 
@@ -365,6 +365,9 @@
         ONLY:  surface_layer_fluxes
 
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
     USE urban_surface_mod,                                                     &
-        ONLY:  usm_material_heat_model, usm_material_model,     &
+        ONLY:  usm_material_heat_model, usm_material_model,                    &
                usm_radiation, usm_surface_energy_balance              
 
@@ -433,5 +436,4 @@
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'start' )
-
 !
 !--    Determine ug, vg and w_subs in dependence on data from external file 
@@ -594,5 +596,4 @@
 !--       velocities at the outflow in case of a non-cyclic lateral wall)
           CALL boundary_conds
-
 !
 !--       Swap the time levels in preparation for the next time step.
@@ -678,6 +679,6 @@
                 IF ( disturbance_energy_limit /= 0.0_wp  .AND.                 &
                      hom(nzb+5,1,pr_palm,0) < disturbance_energy_limit )  THEN
-                   CALL disturb_field( nzb_u_inner, tend, u )
-                   CALL disturb_field( nzb_v_inner, tend, v )
+                   CALL disturb_field( 'u', tend, u )
+                   CALL disturb_field( 'v', tend, v )
                 ELSEIF ( ( .NOT. bc_lr_cyc  .OR.  .NOT. bc_ns_cyc )            &
                      .AND. .NOT. nest_domain )  THEN
@@ -686,6 +687,6 @@
 !--                near the inflow throughout the whole simulation
                    dist_range = 1
-                   CALL disturb_field( nzb_u_inner, tend, u )
-                   CALL disturb_field( nzb_v_inner, tend, v )
+                   CALL disturb_field( 'u', tend, u )
+                   CALL disturb_field( 'v', tend, v )
                    dist_range = 0
                 ENDIF
@@ -728,5 +729,6 @@
 
 !
-!--          First the vertical fluxes in the surface (constant flux) layer are computed
+!--          First the vertical (and horizontal) fluxes in the surface 
+!--          (constant flux) layer are computed
              IF ( constant_flux_layer )  THEN
                 CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'start' )
@@ -737,10 +739,29 @@
 !
 !--          If required, solve the energy balance for the surface and run soil 
-!--          model
+!--          model. Call for horizontal as well as vertical surfaces
              IF ( land_surface .AND. simulated_time > skip_time_do_lsm)  THEN
 
                 CALL cpu_log( log_point(54), 'land_surface', 'start' )
-                CALL lsm_energy_balance
-                CALL lsm_soil_model
+!
+!--             Call for horizontal upward-facing surfaces
+                CALL lsm_energy_balance( .TRUE., -1 )
+                CALL lsm_soil_model( .TRUE., -1 )
+!
+!--             Call for northward-facing surfaces
+                CALL lsm_energy_balance( .FALSE., 0 )
+                CALL lsm_soil_model( .FALSE., 0 )
+!
+!--             Call for southward-facing surfaces
+                CALL lsm_energy_balance( .FALSE., 1 )
+                CALL lsm_soil_model( .FALSE., 1 )
+!
+!--             Call for eastward-facing surfaces
+                CALL lsm_energy_balance( .FALSE., 2 )
+                CALL lsm_soil_model( .FALSE., 2 )
+!
+!--             Call for westward-facing surfaces
+                CALL lsm_energy_balance( .FALSE., 3 )
+                CALL lsm_soil_model( .FALSE., 3 )
+
                 CALL cpu_log( log_point(54), 'land_surface', 'stop' )
              ENDIF
@@ -770,4 +791,5 @@
                 CALL diffusivities( vpt, pt_reference )
              ENDIF
+
              CALL cpu_log( log_point(17), 'diffusivities', 'stop' )
 
@@ -1048,5 +1070,9 @@
 !
 !--    If required, set the heat flux for the next time step at a random value
-       IF ( constant_heatflux  .AND.  random_heatflux )  CALL disturb_heatflux
+       IF ( constant_heatflux  .AND.  random_heatflux )  THEN
+          IF ( surf_def_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_def_h(0) )
+          IF ( surf_lsm_h%ns    >= 1 )  CALL disturb_heatflux( surf_lsm_h    )
+          IF ( surf_usm_h%ns    >= 1 )  CALL disturb_heatflux( surf_usm_h    )
+       ENDIF
 
 !
